;==================================================================================
; Turm - Steuerung
;
; Projektbeschreibung:
; 
;
; Autor:
; Gtz Mayer
;
;==================================================================================
;***********************************************************************************
;**************************     Funktionseinstellung     ***************************
;**************************     Flaksteuerung: 		1    ***************************
;**************************     Geschtzsteuerung: 	2    ***************************
;***********************************************************************************
.EQU VERSION = 2 
;***********************************************************************************

.include "tn24def.inc"

;PortA
.equ	SensorLeft		= 6
.equ	SensorMiddle	= 7

;PortB
.equ	InputR			= 0
.equ	InputL			= 1
.equ	SensorRight		= 2

;.equ	PWM_min 		= 1
;.equ	PWM_max 		= 254

.def	TempA			=	r17
.def	TempB			= 	r18
.def	CounterL		= 	r19
.def	CounterH		= 	r20
.def	Position		=   r21
.def	MotorFlag		=	r22


;***** Initialization
; Address Labels Code Comments
.org 0x0000

	rjmp RESET ; Reset Handler
;	rjmp EXT_INT0 ; IRQ0 Handler
;	rjmp PCINT0_Int ; PCINT0 Handler
;	rjmp PCINT1_Int ; PCINT1 Handler
;	rjmp WATCHDOG ; Watchdog Interrupt Handler
;	rjmp TIM1_CAPT ; Timer1 Capture Handler
;	rjmp TIM1_COMPA ; Timer1 Compare A Handler
;	rjmp TIM1_COMPB ; Timer1 Compare B Handler
;	rjmp TIM1_OVF ; Timer1 Overflow Handler
;	rjmp TIM0_COMPA ; Timer0 Compare A Handler
;	rjmp TIM0_COMPB ; Timer0 Compare B Handler
;	rjmp TIM0_OVF ; Timer0 Overflow Handler
;	rjmp ANA_COMP ; Analog Comparator Handler


; Einsprung
RESET:
		ldi 	r16, low(RAMEND)		 ; Main program start
	   	out 	SPL,r16 				 ; Set Stack Pointer to top of RAM
		wdr
;ini. Port

		;Port init PortA
		ldi		TempA,0b11111111		 ; PortA
		ldi		TempB,0b00111111		 ; DDRA 
;                       ||||||||
;                       |||||||+- 0      - Motor -
;                       ||||||+-- 1      - Motor -
;                       |||||+--- 2      - Motor -
;                       ||||+---- 3      - Motor +
;                       |||+----- 4      - Motor +/SCL
;                       ||+------ 5      - Motor +/MISO
;                       |+------- 6      - SensorLinks/MOSI
;                       +-------- 7      - SensorMitte
		out		PortA,TempA
		out		DDRA,TempB
		
		;Port init PortB
		ldi		TempA,0b00000111		 ; PortB
		ldi		TempB,0b00000000		 ; DDRB
;                       ||||||||
;                       |||||||+- 0      - Input R
;                       ||||||+-- 1      - Input L
;                       |||||+--- 2      - SensorRechts
;                       ||||+---- 3      - RESET
;                       |||+----- 4      - nicht nach auen gefhrt
;                       ||+------ 5      - nicht nach auen gefhrt
;                       |+------- 6      - nicht nach auen gefhrt
;                       +-------- 7      - nicht nach auen gefhrt
		out		PortB,TempA
		out		DDRB,TempB

		;MCUCR Config
;		ldi		TempA,0b00100000
;                       ||||||||
;                       |||||||+- 0      - ISC00
;                       ||||||+-- 1      - ISC01
;                       |||||+--- 2      - unused
;                       ||||+---- 3      - SM0
;                       |||+----- 4      - SM1
;                       ||+------ 5      - Sleep Enable = 1
;                       |+------- 6      - PUD
;                       +-------- 7      - unused
;		out		MCUCR,TempA

		;GIMSK Config
;		ldi		TempA,0b00010000
;                       ||||||||
;                       |||||||+- 0      - unused
;                       ||||||+-- 1      - unused
;                       |||||+--- 2      - unused
;                       ||||+---- 3      - unused
;                       |||+----- 4      - PCIE0 Pin change Interrut Pin0..7 enable = 1
;                       ||+------ 5      - PCIE1
;                       |+------- 6      - INT0
;                       +-------- 7      - unused
;		out		GIMSK,TempA

		;PCMSK0 Config
;		ldi		TempA,0b00000001
;                       ||||||||
;                       |||||||+- 0      - PCINT0 Pin change Int0 enable = 1
;                       ||||||+-- 1      - PCINT1
;                       |||||+--- 2      - PCINT2
;                       ||||+---- 3      - PCINT3
;                       |||+----- 4      - PCINT4
;                       ||+------ 5      - PCINT5
;                       |+------- 6      - PCINT6
;                       +-------- 7      - PCINT7
;		out		PCMSK0,TempA


		;TCCR0B Config
;		ldi		TempA,0b00000011
;                       ||||||||
;                       |||||||+- 0      - CS00
;                       ||||||+-- 1      - CS01
;                       |||||+--- 2      - CS02
;                       ||||+---- 3      - WGM02
;                       |||+----- 4      - unused
;                       ||+------ 5      - unused
;                       |+------- 6      - FOC0B
;                       +-------- 7      - FOC0A
;		out		TCCR0B,TempA
		
		ldi		Position,0	


.IF VERSION==1
Main:
		cpi		Position,0
		brne	MotorOn
		sbis	PinB,InputR				; gelb
		rcall	PosRight
		rjmp	EndMain

MotorOn:
		cpi		Position,1		
		brne	MotorNotLeft
		rcall	PosRight
		rjmp	CheckOff
		
MotorNotLeft:
		cpi		Position,2	
		brne	CheckOff
		rcall	PosLeft

CheckOff:
		sbic	PinB,InputR				; grn
		rcall	PosMiddle

EndMain:
		rjmp	Main
.ENDIF



.IF VERSION==2
Main:
		sbis	PinB,InputR				; gelb
		rcall	CheckPosR

		sbis	PinB,InputL				; grn
		rcall	CheckPosL

		rjmp	Main
.ENDIF


CheckPosR:
		cpi		Position,0
		brne	CheckPosRNotPos0
		rcall	PosRight
		rjmp	EndCheckPosR		

CheckPosRNotPos0:		
		cpi		Position,1
		brne	CheckPosRNotPos1
		rcall	PosMiddle
		rjmp	EndCheckPosR		

CheckPosRNotPos1:		
		cpi		Position,2
		brne	EndCheckPosR
		rcall	PosLeft
		rjmp	EndCheckPosR	

EndCheckPosR:
		sbis	PinB,InputR
		rjmp	EndCheckPosR
		ret		



CheckPosL:
		cpi		Position,0
		brne	CheckPosLNotPos0
		rcall	PosLeft
		rjmp	EndCheckPosL		

CheckPosLNotPos0:		
		cpi		Position,1
		brne	CheckPosLNotPos1
		rcall	PosRight
		rjmp	EndCheckPosL		

CheckPosLNotPos1:		
		cpi		Position,2
		brne	EndCheckPosL
		rcall	PosMiddle
		rjmp	EndCheckPosL	

EndCheckPosL:
		sbis	PinB,InputL
		rjmp	EndCheckPosL
		ret	

;***********************************************************************************
;***************************     Subroutines     ***********************************
;***********************************************************************************
PosRight:
		ldi		TempA,0b11111000
		out		PortA,TempA
		sbic	PinB,SensorRight
		rjmp	PosRight
		
		ldi		Position,2		 
		ldi		TempA,0b11111111
		out		PortA,TempA		
		ret

PosLeft:
		ldi		TempA,0b11000111
		out		PortA,TempA
		sbic	PinA,SensorLeft
		rjmp	PosLeft
		
		ldi		Position,1			 
		ldi		TempA,0b11111111
		out		PortA,TempA	
		ret

PosMiddle:
		cpi		Position,0
		breq	EndPosMiddle
		
		cpi		Position,1
		brne	notLeft		
		ldi		TempA,0b11111000
		rjmp	NextPosMiddle

notLeft:
		cpi		Position,2
		brne	EndPosMiddle	
		ldi		TempA,0b11000111

NextPosMiddle:
		out		PortA,TempA

WaitPosMiddle:
		sbic	PinA,SensorMiddle
		rjmp	WaitPosMiddle
		
		ldi		Position,0		 
		ldi		TempA,0b11111111
		out		PortA,TempA	

EndPosMiddle:
		ret



Delay10ms:
		ldi		CounterH,230

DelayLoop:
		ldi		CounterL,7

DelayLoop1:
		dec		CounterL
		brne	DelayLoop1
		dec		CounterH
		brne	DelayLoop
		ret

;***********************************************************************************
;***************************  Interrupt Handler  ***********************************
;***********************************************************************************
EXT_INT0: 			; IRQ0 Handler
PCINT1_Int: 		; PCINT1 Handler
WATCHDOG: 			; Watchdog Interrupt Handler
TIM1_CAPT: 			; Timer1 Capture Handler
TIM1_COMPA: 		; Timer1 Compare A Handler
TIM1_COMPB: 		; Timer1 Compare B Handler
TIM1_OVF: 			; Timer1 Overflow Handler
TIM0_COMPB: 		; Timer0 Compare B Handler
TIM0_OVF: 			; Timer0 Overflow Handler
ANA_COMP: 			; Analog Comparator Handler
		reti;

